********************************************************************************

*Table D.2. Summary Statistics

********************************************************************************		

use App_results6.dta, clear

foreach v in 1 2 4 5  {
merge 1:1 time statefip using "App_results`v'.dta", gen(mrg`v')
}
save App_results4_22.dta, replace
gen Volume =volume/1000
label var AfterTaxPrice "After\-tax\-price"
label var logprice "log(price)"
label var Utax "State taxes"
label var logtax "Log(taxes)"
label var unemployment "Unemployment"
label var Volume "Sales volume"
label var logvolume "Log(volume)"
label var real_inc_pc "Real per\-capita income"
label var population "Population"
label var licensed "Licensed drivers"
label var road_m "Road miles"
label var my_min_temp "Minimum temperature"
label var my_avg_temp "Average temperature"
label var my_max_temp "Maximum temperature"
label var my_rain_in "Rainfall"

estpost sum AfterTaxPrice logprice Utax logtax unemployment  real_inc_pc ///
population licensed road_m  my_min_temp my_avg_temp my_max_temp my_rain_in Volume logvolume, d
eststo c
esttab c using "summary_stats.tex", replace ///
tex	title("Summary statistics") ///
collabels(\multicolumn{1}{c}{{Mean}} \multicolumn{1}{l}{{SD}} ///
\multicolumn{1}{l}{{p25}}  \multicolumn{1}{l}{{Median}} \multicolumn{1}{l}{{p75}} ) ///
cells("mean(fmt(2)) sd(fmt(2)) p25(fmt(2)) p50(fmt(2)) p75(fmt(2))") label nonumber f  alignment(S) 