********************************************************************************

*Table D.3. First-Stage Estimation

********************************************************************************		


clear
clear mata
clear matrix
set maxvar 30000
use App_results1s.dta, clear
keep  statefip time  *reg* *se* *elasticity* *fstat* *first* *_f_*

foreach j in 1 2 {
foreach i in reg se {
sum `i'_dlogtax_rt_f_2sls`j'
mat `i'a`j'=(r(mean))
sum `i'_new_logtax_f_fe`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum first_1_`i'`j'_logtax
mat `i'a`j'=(`i'a`j',r(mean))
sum `i'_dlogtax_rt_f_w2sls`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum `i'_new_logtax_f_wfe`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum first_1_w_`i'`j'_logtax
mat `i'a`j'=(`i'a`j',r(mean))
}
}
foreach j in  1 2  {
foreach i in fstat {
sum `i'_cd_2sls`j'
mat `i'a`j'=(r(mean))
sum `i'_cd_fe`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum first_`i'_1_`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum `i'_cd_2sls_w`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum `i'_cd_fe_w`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum first_w_`i'_1_`j'
mat `i'a`j'=(`i'a`j',r(mean))

}
mat rownames rega`j'= "Log price"
mat rownames fstata`j'= "First-stage F-statistic"
mat rownames sea`j'= " "
}

mat ee=rega1\sea1\fstata1\rega2\sea2\fstata2

	frmttable using "first.tex", statmat(rega1) replace  tex  ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	sdec(3, 3, 3, 3,3,3  )  multicol(1,2,3;1,5,3)
	frmttable using "first.tex", statmat(sea1) append va tex  ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	dbldiv(" (") brackets("(",")") ///
	sdec(3, 3, 3, 3,3,3  ) multicol(1,2,3;1,5,3)
		frmttable using "first.tex", statmat(fstata1) append va tex ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	addrows("Controls "," N"," N"," N"," N", "N", "N" \ " "," "," "," "," ", " ") ///
		sdec(2, 2, 2, 2,2,2 ) multicol(1,2,3;1,5,3)
		frmttable using "first.tex", statmat(rega2) append va tex  ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	sdec(3, 3, 3, 3,3,3  ) multicol(1,2,3;1,5,3)
	frmttable using "first.tex", statmat(sea2) append va tex  ///
	 dbldiv(" (") brackets("(",")") ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	sdec(3, 3, 3, 3,3,3  ) multicol(1,2,3;1,5,3)
	frmttable using "first.tex", statmat(fstata2) append va tex addrows("Controls "," Y"," Y"," Y"," Y", "Y", "Y") ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
		sdec(2, 2, 2, 2,2,2 ) multicol(1,2,3;1,5,3)
	
