********************************************************************************

*Table D.5. State-Specific Statistics				

********************************************************************************	

use App_results4_22.dta, clear

qui gen staten=statename
qui replace staten=substr(staten, 1,2) + "*" if statename=="DC"
qui replace staten=substr(staten, 1,2) + "*" if statename=="GA"
qui replace staten=substr(staten, 1,2) + "*" if statename=="IN"
qui replace staten=substr(staten, 1,2) + "*" if statename=="HI"
qui replace staten=substr(staten, 1,2) + "*" if statename=="MI"
qui egen stateid2=group(staten)
 *labmask stateid2, values(staten)

	
preserve
keep if date==1990
	
qui levelsof stateid2, local(id2)
foreach i of local id2 {    
	label define state `i' `"`=staten[`i']'"', modify
}

label values stateid2 state
	
*sort statename
forv i =1/26 {
mat a`i'=(stateid2[`i'])
foreach j in  first_1_b1_logtax temp_first_w_fstat_1_1  b1_logprice{
mat a`i'=(a`i',`j'[`i'])
}
}

forv k =27/51 {
local i=`k'-26
mat a`i'=(a`i',stateid2[`k'])
foreach j in  first_1_b1_logtax temp_first_w_fstat_1_1  b1_logprice{
mat a`i'=(a`i',`j'[`k'])
}
}	

	frmttable using "STsp.tex", statmat(a1) replace  tex va ///
ctitles("State" "First-stage ","First-stage ", "Second-Stage","State" "First-stage ", "First-stage ", "Second-Stage" \ " ", "Coefficient", "F-stat", "Coefficient", " ", "Coefficient", "F-stat", "Coefficient") 
		
	forv i =2/26 {	
		frmttable using "STsp.tex", statmat(a`i') append  tex va  ///
ctitles("State" "First-stage ","First-stage ", "Second-Stage","State" "First-stage ", "First-stage ", "Second-Stage" \ " ", "Coefficient", "F-stat", "Coefficient", " ", "Coefficient", "F-stat", "Coefficient")  
		}
	restore	
