********************************************************************************

*Table E.1. Anticipatory Behavior Analysis

********************************************************************************		
	
clear
clear mata
clear matrix
set maxvar 30000
use App_results3.dta, clear
keep statename statefip time year month *reg* *se* *elasticity* *fstat* *rf*

ren  *f1dlogtax_rt* *flogtax*
ren *fnew_logtax* *flogtax*
ren  *dlogtax_rt* *logtax*
ren *new_logtax* *logtax*


foreach j in flogtax logtax {
foreach i in reg se {
sum `i'_`j'_rf_2sls3
mat `i'a`j'=(r(mean))
sum `i'_`j'_rf_fe3
mat `i'a`j'=(`i'a`j',r(mean))
sum rf_`i'3_`j'
mat `i'a`j'=(`i'a`j',r(mean))
sum `i'_`j'_rf_w2sls3
mat `i'a`j'=(`i'a`j',r(mean))
sum `i'_`j'_rf_wfe3
mat `i'a`j'=(`i'a`j',r(mean))
sum rf_w_`i'3_`j'
mat `i'a`j'=(`i'a`j',r(mean))
}

}

foreach i in fstat {
sum `i'_cd_2sls3
mat `i'a=(r(mean))
sum `i'_cd_fe3
mat `i'a=(`i'a,r(mean))
sum first_`i'_1_3
mat `i'a=(`i'a,r(mean))
sum `i'_cd_2sls_w3
mat `i'a=(`i'a,r(mean))
sum `i'_cd_fe_w3
mat `i'a=(`i'a,r(mean))
sum first_w_`i'_1_3
mat `i'a=(`i'a,r(mean))

}

mat rownames regalogtax= "Log tax"
mat rownames sealogtax= " "
mat rownames regaflogtax= "Lead of log tax"
mat rownames seaflogtax= " "
mat rownames fstata= "First-stage F-statistic"


	frmttable using "AB.tex", statmat(regalogtax) replace  tex  ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	sdec(3, 3, 3, 3,3,3  )  multicol(1,2,3; 1,5,3)
	frmttable using "AB.tex", statmat(sealogtax) append va tex  ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	dbldiv(" (") brackets("(",")") ///
	sdec(3, 3, 3, 3,3,3  ) multicol(1,2,3; 1,5,3) 
	frmttable using "AB.tex", statmat(regaflogtax) append va tex  ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	sdec(3, 3, 3, 3,3,3  ) multicol(1,2,3; 1,5,3)
	frmttable using "AB.tex", statmat(seaflogtax) append va tex  ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	 dbldiv(" (") brackets("(",")") ///
	sdec(3, 3, 3, 3,3,3  ) multicol(1,2,3; 1,5,3) 
	frmttable using "AB.tex", statmat(fstata) append va tex ///
	ctitles(" ", "Without volume weights", "", "","Volume weighted", "", "" \"", "P2SLS","FEIV","PCIV","P2SLS","FEIV","PCIV" )  ///
	addrows( " "," "," "," "," ", " ") ///
	sdec(2, 2, 2, 2,2,2 )  multicol(1,2,3;1,5,3)
