#delimit;
clear all;
set more off;
set memory 1500m;
set matsize 1000;
global basedirectory "C:\Users\ksa_4\Desktop\Work\Michael\newdata\";
graph set eps fontface Garamond;
graph set print logo off;

*Monthly Prices Gasoline By State (83-07);
*In DOE site, select "area" for the State breakdown, open EXCEL file, delete heading (top two rows), and save as .csv file;
*http://tonto.eia.doe.gov/dnav/pet/pet_pri_allmg_d_nus_PTA_cpgal_m.htm;

*Prime Supplier Sales Volumes;
*In DOE site, select "area" for the State breakdown, open EXCEL file, delete heading (top two rows), and save as .csv file;
*http://tonto.eia.doe.gov/dnav/pet/pet_cons_prim_dcu_SDE_m.htm;

*----------------------------------------*;
*--------------VOLUMES-------------------*;
*----------------------------------------*;
insheet using "${basedirectory}pet_cons_prim_a_EPM0_P00_Mgalpd_m.csv";
rename alab xAL; rename alas xAK;   rename ariz xAZ;   rename arka xAR;   rename cali xCA;  rename colo xCO;   rename conn xCT;
rename dela xDE; rename dist xDC;   rename flor xFL;   rename geor xGA;   rename hawa xHI;  rename idah xID;   rename illi xIL; 
rename indi xIN; rename iowa xIA;   rename kans xKS;   rename kent xKY;   rename loui xLA;  rename main xME;   rename mary xMD; 
rename mass xMA; rename mich xMI;   rename minn xMN;   rename missi xMS;  rename misso xMO; rename mont xMT;   rename nebr xNE; 
rename neva xNV; rename newh xNH;   rename newj xNJ;   rename newm xNM;   rename newy xNY;  rename northc xNC; rename northd xND; 
rename ohio xOH; rename okla xOK;   rename oreg xOR;   rename penn xPA;   rename rhod xRI;  rename southc xSC; rename southd xSD;
rename tenn xTN; rename texa xTX;   rename utah xUT;   rename verm xVT;   rename virg xVA;  rename wash xWA;   rename westv xWV;   
rename wisc xWI; rename wyom xWY;   rename usto xUS;
drop eastcoastpadd newenglandpadd centralatlanticpadd loweratlanticpadd midwestpadd2totalgasolineallsale gulfcoastpadd3totalgasolineallsa rockymountainpadd4totalgasolinea westcoastpadd5totalgasolineallsa ; 
reshape long x, i(date) j(state) string; rename x volume; drop if volume==.; sort state date;
save "${basedirectory}temp1.dta", replace; clear;

*----------------------------------------*;
*--------------PRICES--------------------*;
*----------------------------------------*;
insheet using "${basedirectory}PET_PRI_ALLMG_A_EPM0_PTA_CPGAL_M.csv";
rename alab xAL; rename alas xAK;   rename ariz xAZ;   rename arka xAR;   rename cali xCA;  rename colo xCO;   rename conn xCT;
rename dela xDE; rename dist xDC;   rename flor xFL;   rename geor xGA;   rename hawa xHI;  rename idah xID;   rename illi xIL; 
rename indi xIN; rename iowa xIA;   rename kans xKS;   rename kent xKY;   rename loui xLA;  rename main xME;   rename mary xMD; 
rename mass xMA; rename mich xMI;   rename minn xMN;   rename missi xMS;  rename misso xMO; rename mont xMT;   rename nebr xNE; 
rename neva xNV; rename newh xNH;   rename newj xNJ;   rename newm xNM;   rename newy xNY;  rename northc xNC; rename northd xND; 
rename ohio xOH; rename okla xOK;   rename oreg xOR;   rename penn xPA;   rename rhod xRI;  rename southc xSC; rename southd xSD;
rename tenn xTN; rename texa xTX;   rename utah xUT;   rename verm xVT;   rename virg xVA;  rename wash xWA;   rename westv xWV;   
rename wisc xWI; rename wyom xWY;   rename usto xUS;
drop eastcoastpadd1totalgasolineretai newenglandpadd1atotalgasolineret centralatlanticpadd1btotalgasoli loweratlanticpadd1ctotalgasoline midwestpadd2totalgasolineretails gulfcoastpadd3totalgasolineretai rockymountainpadd4totalgasoliner westcoastpadd5totalgasolineretai;
reshape long x, i(date) j(state) string; rename x price; sort state date; 
merge state date using "${basedirectory}temp1.dta"; drop _merge; erase "${basedirectory}temp1.dta";

*----------------------------------------*;
*--------USE STANDARD STATE FIPS---------*;
*----------------------------------------*;
gen statefip=.;   
replace statefip=1 if state=="AL";  replace statefip=2 if state=="AK";  replace statefip=4 if state=="AZ";  replace statefip=5 if state=="AR";
replace statefip=6 if state=="CA";  replace statefip=8 if state=="CO";  replace statefip=9 if state=="CT";  replace statefip=10 if state=="DE";
replace statefip=11 if state=="DC"; replace statefip=12 if state=="FL"; replace statefip=13 if state=="GA"; replace statefip=15 if state=="HI";
replace statefip=16 if state=="ID"; replace statefip=17 if state=="IL"; replace statefip=18 if state=="IN"; replace statefip=19 if state=="IA";
replace statefip=20 if state=="KS"; replace statefip=21 if state=="KY"; replace statefip=22 if state=="LA"; replace statefip=23 if state=="ME";
replace statefip=24 if state=="MD"; replace statefip=25 if state=="MA"; replace statefip=26 if state=="MI"; replace statefip=27 if state=="MN";
replace statefip=28 if state=="MS"; replace statefip=29 if state=="MO"; replace statefip=30 if state=="MT"; replace statefip=31 if state=="NE";
replace statefip=32 if state=="NV"; replace statefip=33 if state=="NH"; replace statefip=34 if state=="NJ"; replace statefip=35 if state=="NM";
replace statefip=36 if state=="NY"; replace statefip=37 if state=="NC"; replace statefip=38 if state=="ND"; replace statefip=39 if state=="OH";
replace statefip=40 if state=="OK"; replace statefip=41 if state=="OR"; replace statefip=42 if state=="PA"; replace statefip=44 if state=="RI";
replace statefip=45 if state=="SC"; replace statefip=46 if state=="SD"; replace statefip=47 if state=="TN"; replace statefip=48 if state=="TX";
replace statefip=49 if state=="UT"; replace statefip=50 if state=="VT"; replace statefip=51 if state=="VA"; replace statefip=53 if state=="WA";
replace statefip=54 if state=="WV"; replace statefip=55 if state=="WI"; replace statefip=56 if state=="WY"; rename state statename;
save "${basedirectory}temp2.dta", replace;

*----------------------------------------*;
*-------------PREPARE CPI DATA-----------*;
*----------------------------------------*;
*CPI downloaded from BLS, all urban consumers, excluding energy;
insheet using "${basedirectory}cpi.csv", clear;
rename value cpi; rename period mon; drop seriesid;
gen month=0; replace month=1 if mon=="Jan"; replace month=2  if mon=="Feb"; replace month=3  if mon=="Mar"; replace month=4  if mon=="Apr"; 
		 replace month=5 if mon=="May"; replace month=6  if mon=="Jun"; replace month=7  if mon=="Jul"; replace month=8  if mon=="Aug";  
		 replace month=9 if mon=="Sep"; replace month=10 if mon=="Oct"; replace month=11 if mon=="Nov"; replace month=12 if mon=="Dec"; drop mon;
drop if year<1989; sort year month; save "${basedirectory}cpi.dta", replace; clear;

*----------------------------------------*;
*--------CREATE YEAR AND MONTH-----------*;
*----------------------------------------*;
use "${basedirectory}temp2.dta", clear; erase "${basedirectory}temp2.dta";
gen year=real(substr(date,5,9));
replace year=1900+year if year>80; replace year=2000+year if year<19; 
gen mon=substr(date,1,3); drop date;
gen month=0; replace month=1 if mon=="Jan"; replace month=2  if mon=="Feb"; replace month=3  if mon=="Mar"; replace month=4  if mon=="Apr"; 
		 replace month=5 if mon=="May"; replace month=6  if mon=="Jun"; replace month=7  if mon=="Jul"; replace month=8  if mon=="Aug";  
		 replace month=9 if mon=="Sep"; replace month=10 if mon=="Oct"; replace month=11 if mon=="Nov"; replace month=12 if mon=="Dec"; drop mon;
gen date=year+(month-1)/12;

*----------------------------------------*;
*----IMPUTE MISSING PRICES AND VOLUMES---*;
*----------------------------------------*;
bysort statefip: ipolate volume date, gen(i_volume) epolate;
bysort statefip: ipolate price date, gen(i_price) epolate;
replace volume=i_volume if volume==.;
replace price=i_price   if price==.;
drop i_volume i_price;

*-----------------------------------------------------*;
*----------MERGE WITH UNEMPLOYMENT DATA---------------*;
*-----------------------------------------------------*;
sort statefip year month;
merge statefip year month using "${basedirectory}unemp.dta";
keep if _merge==3; drop _merge;

*-----------------------------------------------------*;
*----------------MERGE WITH TAX DATA------------------*;
*-----------------------------------------------------*;
*THE DOT DATA DESCRIBE ONLY THE PER UNIT TAX, AD VALOREM TAXES ARE ADDED IN BELOW;
drop if statefip==.;
sort statefip year month;
merge statefip year month using "${basedirectory}taxrates.dta";
keep if _merge==3; drop _merge;

*---------------------------------------------------*;
*-----INCORPORATE AD VALOREM TAX WHERE NECESSARY----*;
*---------------------------------------------------*;
gen Utax=statetax+fedtax;   *Utax denotes the tax, here nominal, in cents per gallon;
gen AfterTaxPrice=price+fedtax+statetax;
*replace AfterTaxPrice=price+statetax if (year==2011 & month<3 | year<2011);
replace AfterTaxPrice=(price+statetax+fedtax)*(1.06) if state=="California";
replace AfterTaxPrice=(price+fedtax)*(1.04)+statetax if state=="Georgia" & year>=1992;
replace AfterTaxPrice=(price+fedtax)*(1.03)+statetax if state=="Georgia" & year<1992;
replace AfterTaxPrice=(price)*(1.04)+statetax+fedtax if state=="Hawaii";
replace AfterTaxPrice=(price)*(1.06)+statetax+fedtax if state=="Illinois" & year<1990;
replace AfterTaxPrice=(price)*(1.0625)+statetax+fedtax if state=="Illinois" & year>=1990 & year<=2000;
replace AfterTaxPrice=(price)*(1.06)+statetax+fedtax if state=="Indiana" & year>=2003;
replace AfterTaxPrice=(price)*(1.05)+statetax+fedtax if state=="Indiana" & year<2003;
replace AfterTaxPrice=(price+fedtax)*(1.06)+statetax if state=="Michigan" & year>=1994;
replace AfterTaxPrice=(price+fedtax)*(1.04)+statetax if state=="Michigan" & year<1994;
replace AfterTaxPrice=(price+statetax+fedtax)*(1.06) if state=="Mississippi" & year<=1987;
replace AfterTaxPrice=(price+fedtax)*(1.04)+statetax if state=="New York";
replace AfterTaxPrice=(price+fedtax)*(1.0425)+statetax if state=="New York" & ((year==2003 & month>=6) | year==2004 | (year==2005 & month<6));
replace AfterTaxPrice=(price+fedtax+statetax)*(1.02) if state=="Virginia" & year<=1994;


*-----------------------------------------------------*;
*----------------DEFLATE USING CPI--------------------*;
*-----------------------------------------------------*;
*Base period January 2019 (cpi=259.296);
sort year month;
merge year month using "${basedirectory}cpi.dta";
replace cpi=(cpi/259.296)*100;
drop if _merge!=3; drop _merge;
replace AfterTaxPrice=AfterTaxPrice/(cpi); 
replace Utax=Utax/cpi;
save "${basedirectory}prices&volumes.dta", replace;

*----------------------------------------------------*;
*----------------CREATE VARIABLES--------------------*;
*----------------------------------------------------*;
*PREPARE DATA;
use "${basedirectory}prices&volumes.dta", clear;

gen timevariable = year*12 + month;
rename timevariable time;
tsset statefip time;

gen logprice = log(AfterTaxPrice);
gen logvolume = log(volume);
gen logtax = log(Utax);
gen dlogprice = D.logprice;
gen dlogvolume = D.logvolume;
gen dlogtax = D.logtax;
gen dstatetax = D.statetax;

save "${basedirectory}new_app.dta", replace;
