timer clear
timer on 1



capture program drop sim_dgp
program define sim_dgp, rclass



version 14
syntax [ , obs(integer 250) rxw(real .2) rxu0(real .8) rxu1(real .8) ru1u0(real .5) rwu0(real 0) rwu1(real 0) sd(integer 1) toccs(integer 250) ///
beta1(real 1) beta2(real 2) gamma1(real 3) su0(real .4) su1(real .25) sw(real 1) sx(real 1) ]

drop _all	

set obs `obs'
gen id = _n
gen xvx=`toccs'
sum xvx
return scalar xvx=r(mean)

matrix M =(0, 0, 0)
matrix SD= (`su0', `su1', `sw')	
matrix Rpred = (1, `ru1u0', `rwu0' \ ////
			`ru1u0', 1, `rwu1' \ ////
			`rwu0', `rwu1', 1 )
matrix Rxpred = `rxu0', `rxu1', `rxw'
gen v=rnormal(0,.3)
gen u_12=rnormal(0,`su1')
drawnorm u_0 u_1 w, n(`obs') corr(Rpred) sds(SD) means(M)
*drawnorm x_bar u0 u1 w v, n(`obs')  cov(C) means(M)
gen sd=exp(u_1)
egen sd_bar=mean(sd)
return scalar sd_bar=sd_bar
expand `toccs'
matrix bs_x = Rxpred*inv(Rpred)
local b0 = bs_x[1,1]*`sx'/`su0'
local b1 = bs_x[1,2]*`sx'/`su1'
local b2 = bs_x[1,3]*`sx'/`sw'
gen z=rnormal(0,sd)
generate x = `b0'*u_0 +`b1'*(u_1)+`b2'*w +z+sqrt(1-(`su0'^2)*(`b0')^2-(`su1'^2)*(`b1')^2-(`sw'^2)*(`b2')^2-(2*`b0'*`b1'*`ru1u0'*`su0'*`su1'))*rnormal(0,sd)
generate x22=`b0'*u_0 +`b1'*(u_12)+`b2'*w +z+sqrt(1-(`su0'^2)*(`b0')^2-(`su1'^2)*(`b1')^2-(`sw'^2)*(`b2')^2-(2*`b0'*`b1'*`ru1u0'*`su0'*`su1'))*rnormal(0,sd_bar)


reg x z
predict zhat
reg x22 z
predict zhat2

gen x2=x-zhat+rnormal()     /* x2 is independent of z, correlated with x */
gen x222=x22-zhat2+rnormal()

*Checking correlation of x,z, x2

corr x z

corr x x2

corr x2 z

*Checking demeaned (x,z) & (x2,z)

egen mx=mean(x), by(id)
gen dem_x=x-mx

egen mdem_x=mean(dem_x)

egen mz=mean(z), by(id)
gen dem_z=z-mz

egen mx2=mean(x2), by(id)
gen dem_x2=x2-mx2

gen dem_xz= dem_x*dem_z
gen xz=x*z


gen xXw=x*w
gen zXw=z*w

gen u1Xx=u_1*x


corr u_1 xz /*checking xzu1~=0*/


corr u_1 dem_xz

*Case 2: xzu1=0, let y2 without correlation
reg mx u_1
predict xuhat, resid

gen uu=.4*xuhat + rnormal(0,.3)

*egen u_12=mean(uu), by(id)



*replace u_12=u_12+mx

gen u12Xx=u_12*x

corr u_12 xz /*checking xzu1=0*/
corr u_12 dem_xz

corr u_0 dem_xz

*Checking the mean values of u_0, u_1, x, z, x2, u_12

mean u_0 u_1 u_12 x z x2 

*Generating y
/* without w */
gen y=u_0+(u_1+1)*x+x2+rnormal(0,1.1)  /* Correlated */
gen y2=u_0+(u_12+1)*x22+x222+rnormal(0,1.1) /* Uncorrelated */

foreach i in x dem_x x2 dem_x2 z dem_z xz dem_xz  u_0 u_1 u_12 x22 x222 {
qui sum `i'
return scalar sd`i'=r(sd)
foreach j in x dem_x x2 dem_x2 z dem_z xz dem_xz  u_0 u_1 u_12 x22 x222 {
qui corr `i' `j'
return scalar rho_`i'`j'=r(rho)
}
} 


xtset id

********************************************************************************
/* Notes on Coefficients: Coefficient_method_correlation e.g. alpha_fe_2 */

***Without w

*alpha: coefficient for x

***With w

/* *******_2 for uncorrelated case. (y2 or y4) 
eg) alpha_fe_2: coefficent for x in FEIV from regression on y2.
    beta1_fe_2: coefficent for x in FEIV from regression on y4. */

********************************************************************************

***FIXED IV***
/* without w */

xtivreg2 y (x = z), fe cluster(id) /*This does not change much because z is still correlated with u_1*/
return scalar alpha_fe=_b[x]
return scalar se_alpha_fe=_se[x]

xtivreg2 y2 (x22 = z), fe cluster(id)
return scalar alpha_fe_2=_b[x22]
return scalar se_alpha_fe_2=_se[x22]

***Pooled 2SLS***
/* without w */
ivregress 2sls y (x=z), cluster(id)
return scalar alpha_2sls=_b[x]
return scalar se_alpha_2sls=_se[x]

ivregress 2sls y2 (x22=z), cluster(id)
return scalar alpha_2sls_2=_b[x22]
return scalar se_alpha_2sls_2=_se[x22]

*** Per_Cluster IV
/* without w */
statsby a1=_b[_cons] a2=_b[x], by(id) saving(statsbyn100t250X, replace): ivregress 2sls y (x=z)
sort id
merge m:1 id using statsbyn100t250X
capture egen pickone = tag(id)
drop _merge 


gen res_a2=y-a1-a2*x

gen sum_errors_a2=.


qui sum id
gen size=r(max)
forvalues i = 1/`r(max)' {
matrix accum XZe=x z res_a2 if id==`i', deviations
scalar zx=XZe[1,2] 
scalar zz=XZe[2,2]
scalar ze=XZe[2,3]
scalar e2=XZe[3,3]/(`toccs')
local a=ze/zx
replace sum_errors_a2=`a' if id==`i'
}

egen b_global_a2=mean(a2)
gen dhat_a2=a2-b_global_a2
egen se_a2=sd(dhat_a2+sum_errors_a2)
replace se_a2=se_a2/sqrt(size)

return scalar alpha_statsby=b_global_a2
return scalar se_alpha_statsby=se_a2

statsby a21=_b[_cons] a22=_b[x22], by(id) saving(statsby_2n100t250X, replace): ivregress 2sls y2 (x22=z)
sort id
merge m:1 id using statsby_2n100t250X
drop _merge

gen res_a22=y2-a21-a22*x22

gen sum_errors_a22=.


qui sum id
forvalues i = 1/`r(max)' {
matrix accum XZe2=x22 z res_a22 if id==`i', deviations
scalar zx2=XZe2[1,2] 
scalar zz2=XZe2[2,2]
scalar ze2=XZe2[2,3]
scalar e2=XZe2[3,3]/(`toccs')
local b=ze2/zx2
replace sum_errors_a22=`b' if id==`i'
}

egen b_global_a22=mean(a22)
gen dhat_a22=a22-b_global_a22
egen se_a22=sd(dhat_a22+sum_errors_a22)
replace se_a22=se_a22/sqrt(size)

return scalar alpha_statsby_2=b_global_a22
return scalar se_alpha_statsby_2=se_a22

end



*sim_dgp

***********************************************************************************

foreach oo in 6 /* 7 8 9 10 20 50 100 250 */{
global OBS=`oo'
simulate alpha_fe=r(alpha_fe) se_alpha_fe=r(se_alpha_fe) alpha_2sls=r(alpha_2sls) se_alpha_2sls=r(se_alpha_2sls) ///
 alpha_statsby=r(alpha_statsby) se_alpha_statsby=r(se_alpha_statsby) ///
 alpha_fe_2=r(alpha_fe_2) se_alpha_fe_2=r(se_alpha_fe_2) alpha_2sls_2=r(alpha_2sls_2) se_alpha_2sls_2=r(se_alpha_2sls_2) ///
 alpha_statsby_2=r(alpha_statsby_2) se_alpha_statsby_2=r(se_alpha_statsby_2) ///
 rho_u_12u_1=r(rho_u_12u_1) rho_u_12u_0=r(rho_u_12u_0) rho_u_12dem_xz =r(rho_u_12dem_xz ) ///
 rho_u_12dem_x =r(rho_u_12dem_x ) rho_u_12dem_z =r(rho_u_12dem_z ) rho_u_12dem_x2 =r(rho_u_12dem_x2 ) ///
 rho_u_12x =r(rho_u_12x ) rho_u_12z =r(rho_u_12z ) rho_u_12x2 =r(rho_u_12x2 ) rho_u_12_xz =r(rho_u_12xz ) /// 
 sdu_1=r(sdu_1)  sdu_12=r(sdu_12) sdu_0=r(sdu_0) sddem_xz =r(sddem_xz ) ///
 sddem_x =r(sddem_x ) sddem_z =r(sddem_z ) sddem_x2 =r(sddem_x2 ) ///
 sdx =r(sdx ) sdz =r(sdz ) sdx2 =r(sdx2 ) sd_xz =r(sdxz ) sd_x22=r(sdx22) sd_bar=r(sd_bar) /// 
 rho_u_1u_0=r(rho_u_1u_0) rho_u_1dem_xz =r(rho_u_1dem_xz ) ///
 rho_u_1x =r(rho_u_1x ) rho_u_1z =r(rho_u_1z ) rho_u_1x2 =r(rho_u_1x2 ) rho_u_1_xz =r(rho_u_1xz )  ///
 rho_u_1dem_x =r(rho_u_1dem_x ) rho_u_1dem_z =r(rho_u_1dem_z ) rho_u_1dem_x2 =r(rho_u_1dem_x2 ) ///
  rho_u_0dem_xz =r(rho_u_0dem_xz ) ///
 rho_u_0dem_x =r(rho_u_0dem_x ) rho_u_0dem_z =r(rho_u_0dem_z ) rho_u_0dem_x2 =r(rho_u_0dem_x2 ) ///
 rho_u_0x =r(rho_u_0x ) rho_u_0z =r(rho_u_0z ) rho_u_0x2 =r(rho_u_0x2 ) rho_u_0_xz =r(rho_u_0xz )  ///
 rho_x2dem_x =r(rho_x2dem_x ) rho_x2dem_z =r(rho_x2dem_z ) rho_x2dem_x2 =r(rho_x2dem_x2 ) ///
 rho_x2x =r(rho_x2x ) rho_x2z =r(rho_x2z ) rho_x2xz =r(rho_x2xz )  ///
  rho_zdem_xz =r(rho_zdem_xz ) ///
 rho_zdem_x =r(rho_zdem_x ) rho_zdem_z =r(rho_zdem_z ) rho_zdem_x2 =r(rho_zdem_x2 ) ///
 rho_zx =r(rho_zx ) ///
  rho_xzdem_xz =r(rho_xzdem_xz ) ///
 rho_xzdem_x =r(rho_xzdem_x ) rho_xzdem_z =r(rho_xzdem_z ) rho_xzdem_x2 =r(rho_xzdem_x2 ) ///
 rho_xzx =r(rho_xzx )  ///
  rho_xdem_xz =r(rho_xdem_xz ) ///
 rho_xdem_x =r(rho_xdem_x ) rho_xdem_z =r(rho_xdem_z ) rho_xdem_x2 =r(rho_xdem_x2 ) ///
    rho_dem_xzdem_x =r(rho_dem_xzdem_x ) rho_dem_xzdem_z =r(rho_dem_xzdem_z ) rho_dem_xzdem_x2 =r(rho_dem_xzdem_x2 ) ///
  rho_dem_xdem_z =r(rho_dem_xdem_z ) rho_dem_xdem_x2 =r(rho_dem_xdem_x2 ) ///
  rho_dem_zdem_x2 =r(rho_dem_zdem_x2 ) ///
  rho_x22u_1=r(rho_x22u_1) rho_x22u_0=r(rho_x22u_0) rho_x22dem_xz =r(rho_x22dem_xz ) ///
 rho_x22dem_x =r(rho_x22dem_x ) rho_x22dem_z =r(rho_x22dem_z ) rho_x22dem_x2 =r(rho_x22dem_x2 ) ///
 rho_x22x =r(rho_x22x ) rho_x22z =r(rho_x22z ) rho_x22x2 =r(rho_x22x2 ) rho_x22_xz =r(rho_x22xz ) /// 
, seed(33433)  reps(500) saving(sim_zxu1_`oo'_t250, replace) : sim_dgp, obs($OBS) 

timer off 1
timer list 1

timer clear
}


foreach to in 6 7 8 9 10 20 50 100 250 {
global TOCCS=`to'
simulate xvx=r(xvx) alpha_fe=r(alpha_fe) se_alpha_fe=r(se_alpha_fe) alpha_2sls=r(alpha_2sls) se_alpha_2sls=r(se_alpha_2sls) ///
 alpha_statsby=r(alpha_statsby) se_alpha_statsby=r(se_alpha_statsby) ///
 alpha_fe_2=r(alpha_fe_2) se_alpha_fe_2=r(se_alpha_fe_2) alpha_2sls_2=r(alpha_2sls_2) se_alpha_2sls_2=r(se_alpha_2sls_2) ///
 alpha_statsby_2=r(alpha_statsby_2) se_alpha_statsby_2=r(se_alpha_statsby_2) ///
 rho_u_12u_1=r(rho_u_12u_1) rho_u_12u_0=r(rho_u_12u_0) rho_u_12dem_xz =r(rho_u_12dem_xz ) ///
 rho_u_12dem_x =r(rho_u_12dem_x ) rho_u_12dem_z =r(rho_u_12dem_z ) rho_u_12dem_x2 =r(rho_u_12dem_x2 ) ///
 rho_u_12x =r(rho_u_12x ) rho_u_12z =r(rho_u_12z ) rho_u_12x2 =r(rho_u_12x2 ) rho_u_12_xz =r(rho_u_12xz ) /// 
 sdu_1=r(sdu_1)  sdu_12=r(sdu_12) sdu_0=r(sdu_0) sddem_xz =r(sddem_xz ) ///
 sddem_x =r(sddem_x ) sddem_z =r(sddem_z ) sddem_x2 =r(sddem_x2 ) ///
 sdx =r(sdx ) sdz =r(sdz ) sdx2 =r(sdx2 ) sd_xz =r(sdxz ) sd_x22=r(sdx22) sd_bar=r(sd_bar) /// 
 rho_u_1u_0=r(rho_u_1u_0) rho_u_1dem_xz =r(rho_u_1dem_xz ) ///
 rho_u_1x =r(rho_u_1x ) rho_u_1z =r(rho_u_1z ) rho_u_1x2 =r(rho_u_1x2 ) rho_u_1_xz =r(rho_u_1xz )  ///
 rho_u_1dem_x =r(rho_u_1dem_x ) rho_u_1dem_z =r(rho_u_1dem_z ) rho_u_1dem_x2 =r(rho_u_1dem_x2 ) ///
  rho_u_0dem_xz =r(rho_u_0dem_xz ) ///
 rho_u_0dem_x =r(rho_u_0dem_x ) rho_u_0dem_z =r(rho_u_0dem_z ) rho_u_0dem_x2 =r(rho_u_0dem_x2 ) ///
 rho_u_0x =r(rho_u_0x ) rho_u_0z =r(rho_u_0z ) rho_u_0x2 =r(rho_u_0x2 ) rho_u_0_xz =r(rho_u_0xz )  ///
 rho_x2dem_x =r(rho_x2dem_x ) rho_x2dem_z =r(rho_x2dem_z ) rho_x2dem_x2 =r(rho_x2dem_x2 ) ///
 rho_x2x =r(rho_x2x ) rho_x2z =r(rho_x2z ) rho_x2xz =r(rho_x2xz )  ///
  rho_zdem_xz =r(rho_zdem_xz ) ///
 rho_zdem_x =r(rho_zdem_x ) rho_zdem_z =r(rho_zdem_z ) rho_zdem_x2 =r(rho_zdem_x2 ) ///
 rho_zx =r(rho_zx ) ///
  rho_xzdem_xz =r(rho_xzdem_xz ) ///
 rho_xzdem_x =r(rho_xzdem_x ) rho_xzdem_z =r(rho_xzdem_z ) rho_xzdem_x2 =r(rho_xzdem_x2 ) ///
 rho_xzx =r(rho_xzx )  ///
  rho_xdem_xz =r(rho_xdem_xz ) ///
 rho_xdem_x =r(rho_xdem_x ) rho_xdem_z =r(rho_xdem_z ) rho_xdem_x2 =r(rho_xdem_x2 ) ///
    rho_dem_xzdem_x =r(rho_dem_xzdem_x ) rho_dem_xzdem_z =r(rho_dem_xzdem_z ) rho_dem_xzdem_x2 =r(rho_dem_xzdem_x2 ) ///
  rho_dem_xdem_z =r(rho_dem_xdem_z ) rho_dem_xdem_x2 =r(rho_dem_xdem_x2 ) ///
  rho_dem_zdem_x2 =r(rho_dem_zdem_x2 ) ///
  rho_x22u_1=r(rho_x22u_1) rho_x22u_0=r(rho_x22u_0) rho_x22dem_xz =r(rho_x22dem_xz ) ///
 rho_x22dem_x =r(rho_x22dem_x ) rho_x22dem_z =r(rho_x22dem_z ) rho_x22dem_x2 =r(rho_x22dem_x2 ) ///
 rho_x22x =r(rho_x22x ) rho_x22z =r(rho_x22z ) rho_x22x2 =r(rho_x22x2 ) rho_x22_xz =r(rho_x22xz ) /// 
, seed(33433)  reps(5) saving(sim_zxu1_o250_t`to', replace) : sim_dgp,  toccs($TOCCS) 

*timer off 1
*timer list 1

*timer clear
}

