clear all

local maindir "C:\Users\mbates\Documents\PCIV\JAE"

cd "`maindir'"





foreach n in  6 7 8 9 10 20 50 100 250 {
use "`maindir'\sim_zxu1_`n'_t250.dta"
capture gen clusters=`n'
capture gen tobs=250
save "`maindir'\sim_zxu1_`n't250.dta", replace
clear
}
foreach t in  6 7 8 9 10 20 50 100  {
use "`maindir'\sim_zxu1_o250_t`t'.dta"
capture gen clusters=250
capture gen tobs=`t'
save "`maindir'\sim_zxu1_250t`t'.dta", replace
clear
}
 
 
use "`maindir'\sim_zxu1_7t250.dta"
append using "`maindir'\sim_zxu1_8t250.dta"
append using "`maindir'\sim_zxu1_9t250.dta"
append using "`maindir'\sim_zxu1_10t250.dta"
append using "`maindir'\sim_zxu1_20t250.dta"
append using "`maindir'\sim_zxu1_50t250.dta"
append using "`maindir'\sim_zxu1_100t250.dta"
append using "`maindir'\sim_zxu1_250t100.dta"
append using "`maindir'\sim_zxu1_250t50.dta"
append using "`maindir'\sim_zxu1_250t20.dta"
append using "`maindir'\sim_zxu1_250t10.dta"
append using "`maindir'\sim_zxu1_250t9.dta"
append using "`maindir'\sim_zxu1_250t8.dta"
append using "`maindir'\sim_zxu1_250t7.dta"
append using "`maindir'\sim_zxu1_250t6.dta"
append using "`maindir'\sim_zxu1_6t250.dta"
append using "`maindir'\sim_zxu1_250t250.dta"


gen id=_n
reshape long alpha  se_alpha , i(id) j(type) string
 
gen bias_alpha=alpha-1

foreach i in alpha {
bysort type clusters tobs: egen sd_`i'=sd(`i')
bysort type clusters tobs: egen mean_se_`i'=mean(se_`i')
}
foreach i in alpha {
bysort  type clusters tobs: gen ratio_`i'=mean_se_`i'/sd_`i'
}
foreach i in alpha {
bysort  type clusters tobs: egen rmse_`i'=mean(bias_`i'^2+sd_`i'^2)
replace rmse_`i'=rmse_`i'^(0.5)
}

 

save "sim_zxu1_all.dta", replace

foreach i in 250  {
twoway (kdensity bias_alpha if type=="_2sls_2" & clusters==`i' & tobs==250, lp(dash)) ///
(kdensity bias_alpha if type=="_fe_2"& clusters==`i' & tobs==250, lp(dash_dot_dot)) ///
(kdensity bias_alpha if type=="_statsby_2" & clusters==`i' & tobs==250, lp(solid)), /// 
ytitle("N=`i' T=250") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
xline(0) xlab(-.4(.2).6) ylab(0(10)30)  legend(off)
graph save bias_dens2_n`i't250.gph, replace

twoway (kdensity bias_alpha if type=="_2sls" & clusters==`i' & tobs==250, lp(dash)) ///
(kdensity bias_alpha if type=="_fe"& clusters==`i' & tobs==250, lp(dash_dot_dot)) ///
(kdensity bias_alpha if type=="_statsby" & clusters==`i' & tobs==250, lp(solid)) , ///
 ytitle("") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
xline(0) xlab(-.4(.2).6) ylab(0(10)30)  legend(off)
graph save bias_dens1_n`i't250.gph, replace

}

foreach i in  10 {
twoway (kdensity bias_alpha if type=="_2sls_2" & clusters==`i' & tobs==250, lp(dash)) ///
(kdensity bias_alpha if type=="_fe_2"& clusters==`i' & tobs==250, lp(dash_dot_dot)) ///
(kdensity bias_alpha if type=="_statsby_2" & clusters==`i' & tobs==250, lp(solid)), /// 
 ytitle("N=`i' T=250") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
xline(0) xlab(-.4(.2).6) ylab(0(10)30)  legend(off)
graph save bias_dens2_n`i't250.gph, replace

twoway (kdensity bias_alpha if type=="_2sls" & clusters==`i' & tobs==250, lp(dash)) ///
(kdensity bias_alpha if type=="_fe"& clusters==`i' & tobs==250, lp(dash_dot_dot)) ///
(kdensity bias_alpha if type=="_statsby" & clusters==`i' & tobs==250, lp(solid)) , ///
 ytitle("") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
xline(0) xlab(-.4(.2).6) ylab(0(10)30) legend(off)
graph save bias_dens1_n`i't250.gph, replace
}

twoway  (kdensity bias_alpha if type=="_2sls_2" & clusters==250 & tobs==10, lp(dash)) ///
(kdensity bias_alpha if type=="_fe_2"& clusters==250 & tobs==10, lp(dash_dot_dot)) ///
(kdensity bias_alpha if type=="_statsby_2" & clusters==250 & tobs==10, lp(solid)), ///
legend(label(1 "2SLS") label(2 "FEIV") label(3 "PCIV")  cols(3)) ytitle("") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
xline(0) xlab(-.4(.2).6) ylab(0(10)30) ytitle("N=250 T=10")
graph save bias_dens2_n250t10.gph, replace

twoway (kdensity bias_alpha if type=="_2sls" & clusters==250 & tobs==10, lp(dash)) ///
(kdensity bias_alpha if type=="_fe"& clusters==250 & tobs==10, lp(dash_dot_dot)) ///
(kdensity bias_alpha if type=="_statsby" & clusters==250 & tobs==10 , lp(solid)), ///
legend(label(1 "2SLS") label(2 "FEIV") label(3 "PCIV")  cols(3))  ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
xline(0) xlab(-.4(.2).6) ylab(0(10)30) ytitle("")
graph save bias_dens1_n250t10.gph, replace

gr combine bias_dens2_n250t250.gph bias_dens1_n250t250.gph bias_dens2_n10t250.gph ///
bias_dens1_n10t250.gph bias_dens2_n250t10.gph bias_dens1_n250t10.gph, ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
rows(3) title("Uncorrelated Covariance vs. Correlated Covariance")
graph export bias_dens.eps, replace
graph export bias_dens.png, replace

********************************************************************************
/* Generating Graphs: Bias */
preserve

collapse (mean) bias_alpha  rmse_alpha  ratio_alpha , by(clusters tobs type)

 
foreach i in alpha  {

*Correlated Covariance

twoway (connected bias_`i' clusters if tobs==250 & type=="_2sls", msymbol(O)) ///
(connected bias_`i' clusters if tobs==250 & type=="_fe", msymbol(S)) ///
(connected bias_`i' clusters if tobs==250 & type=="_statsby", msymbol(T)), title("Correlated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Number of Clusters")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(-.1(.05).2)  yline(0) ytitle("") 
graph save bias_`i'T.gph, replace

*Uncorrelated Covariance
twoway (connected bias_`i' clusters if tobs==250 & type=="_2sls_2", msymbol(S)) ///
(connected bias_`i' clusters if tobs==250 & type=="_fe_2", msymbol(S)) ///
(connected bias_`i' clusters if tobs==250 & type=="_statsby_2", msymbol(T)), title("Uncorrelated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Number of Clusters")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(-.1(.05).2)   yline(0) ytitle("") 
graph save bias_`i'_2T.gph, replace

gr combine bias_`i'_2T.gph bias_`i'T.gph, ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
title("Bias with large T as N increases ")
graph export bias_`i'Tfix.eps, replace
graph export bias_`i'Tfix.png, replace

}
restore
preserve

collapse (mean) bias_alpha  rmse_alpha  ratio_alpha , by(clusters tobs type)

 
foreach i in alpha  {

*Correlated Covariance

twoway (connected bias_`i' tobs if clusters==250 & type=="_2sls", msymbol(O)) ///
(connected bias_`i' tobs if clusters==250 & type=="_fe", msymbol(S)) ///
(connected bias_`i' tobs if clusters==250 & type=="_statsby", msymbol(T)), title("Correlated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Observations per cluster")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(-.1(.05).2)   yline(0) ytitle("") 
graph save bias_`i'Nfix.gph, replace

*Uncorrelated Covariance
twoway (connected bias_`i' tobs if clusters==250 & type=="_2sls_2", msymbol(S)) ///
(connected bias_`i' tobs if clusters==250 & type=="_fe_2", msymbol(S)) ///
(connected bias_`i' tobs if clusters==250 & type=="_statsby_2", msymbol(T)), title("Uncorrelated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Observations per cluster")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(-.1(.05).2)  yline(0) ytitle("") 
graph save bias_`i'_2Nfix.gph, replace

gr combine bias_`i'_2Nfix.gph bias_`i'Nfix.gph, ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
title("Bias with large N as T increases ")
graph export bias_`i'Nfix.eps, replace
graph export bias_`i'Nfix.png, replace

}
restore

********************************************************************************
/* Generating Graphs: RMSE */
preserve

collapse (mean) bias_alpha  rmse_alpha  ratio_alpha , by(clusters tobs type)

foreach i in alpha  {

*Correlated Covariance

twoway (connected rmse_`i' clusters if tobs==250 & type=="_2sls", msymbol(O)) ///
(connected rmse_`i' clusters if tobs==250 & type=="_fe", msymbol(S)) ///
(connected rmse_`i' clusters if tobs==250 & type=="_statsby", msymbol(T)), title("Correlated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Number of Clusters") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV") cols(3)) ylab(0(.2)1)
graph save rmse_`i'T.gph, replace

*Uncorrelated Covariance
twoway (connected rmse_`i' clusters if tobs==250 & type=="_2sls_2", msymbol(S)) ///
(connected rmse_`i' clusters if tobs==250 & type=="_fe_2", msymbol(S)) ///
(connected rmse_`i' clusters if tobs==250 & type=="_statsby_2", msymbol(T)), title("Uncorrelated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Number of Clusters") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV") cols(3)) ylab(0(.2)1) 
graph save rmse_`i'_2T.gph, replace

gr combine rmse_`i'_2T.gph rmse_`i'T.gph, ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
title("RMSE with large T as N increases")
graph export rmse_`i'Tfix.eps, replace
graph export rmse_`i'Tfix.png, replace

}

foreach i in alpha  {

*Correlated Covariance

twoway (connected rmse_`i' tobs if clusters==250 & type=="_2sls", msymbol(O)) ///
(connected rmse_`i' tobs if clusters==250 & type=="_fe", msymbol(S)) ///
(connected rmse_`i' tobs if clusters==250 & type=="_statsby", msymbol(T)), title("Correlated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Observations per cluster") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(0(.2)1) 
graph save rmse_`i'N.gph, replace

*Uncorrelated Covariance
twoway (connected rmse_`i' tobs if clusters==250 & type=="_2sls_2", msymbol(S)) ///
(connected rmse_`i' tobs if clusters==250 & type=="_fe_2", msymbol(S)) ///
(connected rmse_`i' tobs if clusters==250 & type=="_statsby_2", msymbol(T)), title("Uncorrelated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Observations per cluster") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(0(.2)1) 
graph save rmse_`i'_2N.gph, replace

gr combine rmse_`i'_2N.gph rmse_`i'N.gph, ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
title("RMSE with large N as T increases")
graph export rmse_`i'Nfix.eps, replace
graph export rmse_`i'Nfix.png, replace

}

*Correlated Covariance

foreach i in alpha {
twoway (connected ratio_`i' clusters if tobs==250 & type=="_2sls", msymbol(O)) ///
(connected ratio_`i' clusters if tobs==250 & type=="_fe", msymbol(S)) ///
(connected ratio_`i' clusters if tobs==250 & type=="_statsby", msymbol(T)), title("Correlated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Number of Clusters") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(.25(.25)1.5) yline(1)
graph save ratio_`i'T.gph, replace

*Uncorrelated Covariance
twoway (connected ratio_`i' clusters if tobs==250 & type=="_2sls_2", msymbol(S)) ///
(connected ratio_`i' clusters if tobs==250 & type=="_fe_2", msymbol(S)) ///
(connected ratio_`i' clusters if tobs==250 & type=="_statsby_2", msymbol(T)), title("Uncorrelated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Number of Clusters") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(.25(.25)1.5) yline(1) 
graph save ratio_`i'_2T.gph, replace

gr combine ratio_`i'_2T.gph ratio_`i'T.gph, ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
title("Ratio of mean SE to SD with large T as N increases")
graph export ratio_`i'Tfix.eps, replace
graph export ratio_`i'Tfix.png, replace

}


foreach i in alpha  {

*Correlated Covariance

twoway (connected ratio_`i' tobs if clusters==250 & type=="_2sls", msymbol(O)) ///
(connected ratio_`i' tobs if clusters==250 & type=="_fe", msymbol(S)) ///
(connected ratio_`i' tobs if clusters==250 & type=="_statsby", msymbol(T)), title("Correlated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Observations per cluster") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(.25(.25)1.5) yline(1) 
graph save ratio_`i'N.gph, replace

*Uncorrelated Covariance
twoway (connected ratio_`i' tobs if clusters==250 & type=="_2sls_2", msymbol(S)) ///
(connected ratio_`i' tobs if clusters==250 & type=="_fe_2", msymbol(S)) ///
(connected ratio_`i' tobs if clusters==250 & type=="_statsby_2", msymbol(T)), title("Uncorrelated Covariance") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Observations per cluster") ytitle("") ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(.25(.25)1.5) yline(1) 
graph save ratio_`i'_2N.gph, replace

gr combine ratio_`i'_2N.gph ratio_`i'N.gph, ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) ///
title("Ratio of mean SE to SD as with large N as T increases")
graph export ratio_`i'Nfix.eps, replace
graph export ratio_`i'Nfix.png, replace

}

restore


preserve

collapse (mean) bias_alpha  rmse_alpha  ratio_alpha sd_alpha, by(clusters tobs type)
split type,  parse(_)
sort clusters tobs type3 type2



export excel using  "C:\Users\mbates\Documents\PCIV\JAE\bias_rmse.xlsx", firstrow(variables) replace
restore

preserve

collapse (mean) rho* sd*, by(clusters tobs type)
split type,  parse(_)
sort clusters tobs type3 type2



export excel using  "C:\Users\mbates\Documents\PCIV\JAE\rho_sd.xlsx", firstrow(variables) replace
restore
