clear all

local maindir "L:\My Drive\Research\recoverATE\simulation\simUCM\4_26" 

cd "`maindir'"





forv n=  0/10 {
use "`maindir'\sim_vz`n'g.dta", clear
capture gen cor_coef=`n'
save "sim_vz`n'g", replace

}
 
  use "sim_vz10g", clear
  *capture gen cor_coef=10
forv n=  0/9 {
append using "`maindir'\sim_vz`n'g.dta"
}


gen id=_n
reshape long alpha  se_alpha , i(id) j(type) string
 
gen bias_alpha=alpha-1

foreach i in alpha {
bysort type cor_coef: egen sd_`i'=sd(`i')
bysort type cor_coef: egen mean_se_`i'=mean(se_`i')
}
foreach i in alpha {
bysort  type cor_coef: gen ratio_`i'=mean_se_`i'/sd_`i'
}
foreach i in alpha {
bysort  type cor_coef: egen rmse_`i'=mean(bias_`i'^2+sd_`i'^2)
replace rmse_`i'=rmse_`i'^(0.5)
}
foreach i in alpha {
 gen temp=`i'+(1.96*se_`i')
 gen temp1=`i'-(1.96*se_`i')
 gen temp2=(1>temp1 & 1<temp)
 egen coverage_`i'=mean(temp2), by(type cor_coef)
}

 

save "sim_vz_all_het.dta", replace

use "sim_vz_all_het.dta", replace
cd "L:\My Drive\Research\recoverATE\simulation\sim_results\"
********************************************************************************
/* Generating Graphs: Bias */
preserve

collapse (mean) bias_alpha  rmse_alpha rho_u_1dem_xz ratio_alpha coverage*, by(cor_coef  type)

 
foreach i in alpha  {
foreach j in bias { 

*Correlated Covariance

twoway (connected `j'_`i' rho_u_1dem_xz if  type=="_2sls", msymbol(S)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_fe", msymbol(O)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_statsby", msymbol(T)), title("Varying correlations with N and T large") ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Correlation between bi and xz")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(-.1(.05).15)  yline(0) ytitle("") 
graph save "`j'_`i'het.gph", replace

graph export `j'_`i'het.png, replace

}
}

foreach i in alpha  {
foreach j in  rmse { 

*Correlated Covariance

twoway (connected `j'_`i' rho_u_1dem_xz if  type=="_2sls", msymbol(S)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_fe", msymbol(O)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_statsby", msymbol(T)), title("Varying correlations with N and T large")  ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Correlation between bi and xz")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(0(.1).4) yline(0) ytitle("") 
graph save "`j'_`i'het.gph", replace

graph export `j'_`i'het.png, replace

}
}

foreach i in alpha  {
foreach j in  ratio { 

*Correlated Covariance

twoway (connected `j'_`i' rho_u_1dem_xz if  type=="_2sls", msymbol(S)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_fe", msymbol(O)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_statsby", msymbol(T)), title("Varying correlations with N and T large")  ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Correlation between bi and xz")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(.25(.25)1.5)  yline(1) ytitle("") 
graph save "`j'_`i'het.gph", replace

graph export `j'_`i'het.png, replace

}
}

foreach i in alpha  {
foreach j in  coverage { 

*Correlated Covariance

twoway (connected `j'_`i' rho_u_1dem_xz if  type=="_2sls", msymbol(S)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_fe", msymbol(O)) ///
(connected `j'_`i' rho_u_1dem_xz if  type=="_statsby", msymbol(T)), title("Varying correlations with N and T large")  ///
graphregion(fcolor(white) ifcolor(white)) plotregion(fcolor(white) ifcolor(white)) xtitle("Correlation between bi and xz")  ///
legend(label(2 "FEIV") label(1 "2SLS") label(3 "PCIV")  cols(3)) ylab(0(.2)1)  yline(.95) ytitle("") 
graph save "`j'_`i'het.gph", replace

graph export `j'_`i'het.png, replace

}
}
